std::experimental::erase_if(std::unordered_map)(3)

NAME
std::experimental::erase_if(std::unordered_map) - std::experimental::erase_if(std::unordered_map)

Synopsis
   Defined in header <experimental/unordered_map>
   template< class Key, class T, class Hash, class KeyEqual,
   class Alloc, class Pred > (library
   void erase_if( std::unordered_map<Key,T,Hash,KeyEqual,Alloc>& fundamentals TS v2)
   c, Pred pred );
   Erases all elements that satisfy the predicate pred from the container. Equivalent
   to
 for (auto i = c.begin(), last = c.end(); i != last; ) {
   if (pred(*i)) {
     i = c.erase(i);
   } else {
     ++i;
   }
 }

Parameters
   c - container from which to erase
   pred - predicate that determines which elements should be erased

Complexity
   Linear.

Example
// Run this code
 #include <experimental/unordered_map>
 #include <iostream>
 template<typename Os, typename Container>
 inline Os& operator<<(Os& os, Container const& cont)
 {
     os << "{";
     for (const auto& item : cont) {
         os << "{" << item.first << ", " << item.second << "}";
     }
     return os << "}";
 }
 int main()
 {
     std::unordered_map<int, char> data {{1, 'a'},{2, 'b'},{3, 'c'},{4, 'd'},
                        {5, 'e'},{4, 'f'},{5, 'g'},{5, 'g'}};
     std::cout << "Original:\n" << data << '\n';
     std::experimental::erase_if(data, [](const auto& item) {
         return (item.first & 1) == 1;
     });
     std::cout << "Erase items with odd keys:\n" << data << '\n';
 }

Possible output:
 Original:
 {{5, e}{4, d}{3, c}{2, b}{1, a}}
 Erase items with odd keys:
 {{4, d}{2, b}}

See also
   remove removes elements satisfying specific criteria
   remove_if (function template)